do
	local oldModBlueprints = ModBlueprints
	function ModBlueprints(all_bps)
		oldModBlueprints(all_bps)

		local	r, v	=	2.0, 1.4	--	range, and velocity multipliers.
		local	e, bias	=	2.0, 1.5	--	RoF exponent, and artificial average adjustment.

		for id, bp in all_bps.Unit do

		--air speed rebalance
			if bp.Air and bp.Air.MaxAirspeed then
				bp.Air.MaxAirspeed=(bp.Air.MaxAirspeed*1.5)
				#LOG('*CIP: ' .. bp.BlueprintId .. ' MaxAirspeed' .. bp.Air.MaxAirspeed)
			end
			if bp.Air and bp.Air.CombatTurnSpeed then
				bp.Air.CombatTurnSpeed=(bp.Air.CombatTurnSpeed*1.5)
				#LOG('*CIP: ' .. bp.BlueprintId .. ' CombatTurnSpeed' .. bp.Air.CombatTurnSpeed)
			end
			if bp.Air and table.find(bp.Categories,'BOMBER') and not(table.find(bp.Categories,'EXPERIMENTAL')) then
				#if bp.Air.BreakOffDistance then bp.Air.BreakOffDistance=(bp.Air.BreakOffDistance*1.5) end
				#if bp.Air.BreakOffTrigger then bp.Air.BreakOffTrigger=(bp.Air.BreakOffTrigger*1.5) end 
			end
			if bp.Air and table.find(bp.Categories,'SERAPHIM') and table.find(bp.Categories,'HIGHALTAIR') and table.find(bp.Categories,'EXPERIMENTAL') then
				if bp.Air.BreakOffDistance then bp.Air.BreakOffDistance=(bp.Air.BreakOffDistance*1.5) end
				if bp.Air.BreakOffTrigger then bp.Air.BreakOffTrigger=(bp.Air.BreakOffTrigger*2) end 
			end

			if bp.Enhancements then
				
				for ik, enh in bp.Enhancements do

					if enh.NewMaxRadius then
						enh.NewMaxRadius = math.floor(enh.NewMaxRadius*r)
						#LOG('*CIP: ' .. bp.BlueprintId .. ' NewMaxRadius' .. enh.NewMaxRadius)
					end
					
					if enh.ZephyrRangeMod then
						enh.ZephyrRangeMod = math.floor(enh.ZephyrRangeMod*r)
						#LOG('*CIP: ' .. bp.BlueprintId .. ' ZephyrRangeMod' .. enh.ZephyrRangeMod)
					end

					if enh.AMCannonRangeMod then
						enh.AMCannonRangeMod = math.floor(enh.AMCannonRangeMod*r)
						#LOG('*CIP: ' .. bp.BlueprintId .. ' AMCannonRangeMod' .. enh.AMCannonRangeMod)
					end

					if enh.BaseWeaponRange then
						enh.BaseWeaponRange = math.floor(enh.BaseWeaponRange*r)
						#LOG('*CIP: ' .. bp.BlueprintId .. ' BaseWeaponRange' .. enh.BaseWeaponRange)
					end
					
				end
				
			end

			if bp.Weapon then
				for ik, wep in bp.Weapon do
					if wep.MaxRadius and not (wep.RangeCategory == 'UWRC_Countermeasure') and (not(table.find(bp.Categories,'BOMBER')) or (table.find(bp.Categories,'BOMBER')and(wep.RangeCategory == 'UWRC_AntiAir'))) then
						wep.MaxRadius = math.floor(wep.MaxRadius * r)
						if table.find(bp.Categories,'COMMAND') then LOG('*CC: ' .. bp.BlueprintId .. ' ' .. wep.DisplayName ..' Range' .. wep.MaxRadius) end
						if wep.MaxRadius > 4000 then wep.MaxRadius = 4000 end
					elseif wep.MaxRadius and wep.TargetRestrictOnlyAllow and (wep.TargetRestrictOnlyAllow=='TACTICAL MISSILE'  or wep.TargetRestrictOnlyAllow=='TACTICAL,MISSILE')then
						if table.find(bp.Categories,'CYBRAN') then
							wep.MaxRadius = math.floor(wep.MaxRadius * 2)
						elseif table.find(bp.Categories,'AEON') then
							wep.RateOfFire = wep.RateOfFire*1.5
						elseif table.find(bp.Categories,'UEF') then
							wep.MaxRadius = math.floor(wep.MaxRadius * 2)
						elseif table.find(bp.Categories,'SERAPHIM') then
							wep.MaxRadius = math.floor(wep.MaxRadius * 2)
						end
					end

					if wep.MuzzleVelocity and (bp.General.Category != 'Bomber') then
						local g = 2.45
						if wep.BallisticArc == 'RULEUBA_HighArc' then
							if wep.TurretPitch and wep.TurretPitchRange then
								wep.MuzzleVelocity=math.pow(wep.MaxRadius*2*g,0.5)
								local a=wep.TurretPitch+wep.TurretPitchRange
								if a<65 and not table.find(bp.Categories,'SERAPHIM') then
									wep.BallisticArc = 'RULEUBA_LowArc'
								elseif a<90 and not table.find(bp.Categories,'SERAPHIM') then
									wep.TurretPitch=55
								end
								local ar=85*math.pi/180
								local newminrad = math.pow(wep.MuzzleVelocity,2)*math.sin(ar)*math.cos(ar)/g
								if newminrad < 150 then wep.MinRadius=newminrad end
								LOG('*CIP: ' .. bp.BlueprintId .. ' A=' .. a .. ' V=' .. wep.MuzzleVelocity .. ' minR=' .. wep.MinRadius .. ' maxR=' .. wep.MaxRadius)
							end
						elseif wep.BallisticArc == 'RULEUBA_LowArc' and (wep.MuzzleVelocity*v*1.5)<math.pow(wep.MaxRadius*2*g,0.5) then
							wep.MuzzleVelocity = math.pow(wep.MaxRadius*2*g,0.5)
						else
							wep.MuzzleVelocity = wep.MuzzleVelocity * v
						end
						if wep.MuzzleVelocityReduceDistance then
							wep.MuzzleVelocityReduceDistance = wep.MuzzleVelocityReduceDistance*r
						end
					end

				
					if wep.MinRadius and (bp.General.Category != 'Gunship') then
						#wep.MinRadius = wep.MinRadius * r
					end
					
					if wep.ProjectileLifetime then
						wep.ProjectileLifetime = wep.ProjectileLifetime * r
					end
					
					if wep.FiringRandomness then
						#wep.FiringRandomness = wep.FiringRandomness * gain
					else
						#wep.FiringRandomness = 0.01
					end


				end	--	bp.Weapon loop

			end
		
			if bp.Wreckage and bp.Wreckage.HealthMult then
				bp.Wreckage.HealthMult	=	10
			end
			
		end	--	all_bps.Unit loop
	end	--	ModBlueprints

end
